/*
	Esame del 23/09/2002
	Scrivere un metodo statico Java che, date due chiavi 
	e un albero binario di ricerca, restituisca il nodo 
	antenato pi vicino ai nodi con le chiavi fornite.
	Nota: le chiavi possono essere non presenti nell'albero.
*/

public class AntenatoVicino
{
	public static IntBSTNode LCA (IntBST a, int n, int m)
	{
		if (a.iterativeSearch(a.getRoot(),n) == null || a.iterativeSearch(a.getRoot(),m) == null)
			throw new KeyNotFoundException();
		IntBSTNode aux = a.getRoot();
		while ((n < aux.getKey() && m < aux.getKey()) || (n > aux.getKey() && m > aux.getKey()))
		{
			if (n < aux.getKey() && m < aux.getKey())
				aux = aux.getLeft();
			else
				aux = aux.getRight();
		}
		return aux;
	}

	//main:
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader ();
		System.out.print ("Quanti nodi? ");
		int nodi = console.readInt ();
		IntBST albero = new IntBST();
		int i = 1;
		try
		{
			for ( ; i <= nodi; i++)
			{
				System.out.print ("Nodo "+i+": ");
				albero.insert(console.readInt());
			}
		}
		catch (NodeFoundException e)
		{
			i -= i;
		}
		System.out.print ("Dammi N: ");
		int n = console.readInt();
		System.out.print ("Dammi M: ");
		int m = console.readInt();
		try
		{
			System.out.println (
			"L'antenato piu' vicino a "+n+" ed "+m+" e': "+LCA(albero,n,m).getKey());
		}
		catch (KeyNotFoundException e)
		{
			System.out.print ("Hai inserito valori di N o M non presenti");
		}
		System.exit(1);
	}
}
