//Classe con metodi per l'inizializzazione e la stampa di alberi binari:

public class BinaryTrees
{
	/*************************************************************
	*****************Inizalizzazione di IntBST********************
	*************************************************************/
	public static void inizialize (IntBST tree)
	{
		ConsoleReader console = new ConsoleReader();
		boolean flag = false;
		String scelta = "";
		while (!flag)
		{
			System.out.print ("Vuoi inserire un nodo? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				System.out.print ("Inserisci un intero: ");
				try
				{
					tree.insert (console.readInt());
				}
				catch (RuntimeException e)
				{
					System.out.println ("Impossibile inserirlo, riprova");
				}
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}
	}

	/*************************************************************
	***************Metodi per la stampa a schermo*****************
	*************************************************************/
	
	//Stampa in PREORDER:
	public static void printPreorder (IntBST tree)
	{
		if (tree.isEmpty(tree.getRoot()))
			throw new EmptyTreeException ();
		printPreorder (tree.getRoot());
	}

	private static void printPreorder (IntBSTNode node)
	{
		if (node != null)
		{
			System.out.print (node.getKey()+" ");
			printPreorder (node.getLeft());
			printPreorder (node.getRight());
		}
	}

	//Stampa in INORDER:
	public static void printInorder (IntBST tree)
	{
		if (tree.isEmpty(tree.getRoot()))
			throw new EmptyTreeException ();
		printInorder (tree.getRoot());
	}

	private static void printInorder (IntBSTNode node)
	{
		if (node != null)
		{
			printInorder (node.getLeft());
			System.out.print (node.getKey()+" ");
			printInorder (node.getRight());
		}
	}

	//Stampa in POSTORDER:
	public static void printPostorder (IntBST tree)
	{
		if (tree.isEmpty(tree.getRoot()))
			throw new EmptyTreeException ();
		printPostorder (tree.getRoot());
	}

	private static void printPostorder (IntBSTNode node)
	{
		if (node != null)
		{
			printPostorder (node.getLeft());
			printPostorder (node.getRight());
			System.out.print (node.getKey()+" ");
		}
	}

	//Stampa speculare:
	public static void printBST (IntBST tree)
	{
		if (tree.isEmpty())
			throw new EmptyTreeException ();
		printBST (tree.getRoot());
	}

	private static void printBST (IntBSTNode node)
	{
		if (node != null)
		{
			System.out.print ("	");
			printBST (node.getRight());
			System.out.println (node.getKey());
			System.out.print ("	");
			printBST (node.getLeft());
		}
	}
}