/**
	Classe ConsoleReader per la gestione dell'input da linea di comando
	@author Fabio Rinnone
	@version 0.1 del 20/03/2002
*/

import java.io.*;

public class ConsoleReader
{
	private BufferedReader reader;

	//Costruttore
	public ConsoleReader ()
	{
		reader = new BufferedReader (new InputStreamReader (System.in));
		//sto dichiarando un nuovo flusso (stream) per i dati in ingresso
	}

	//primo metodo: lettura di una riga di testo (restituisce una String)
	public String readLine ()
	{
		String inputLine = "";
		//occorre gestire un eventuale eccezione di I/O
		try {
			inputLine = reader.readLine();
		}
		catch (IOException e) {
			System.out.println (e);
			System.exit(1);
		}
		return inputLine;
	}

	//secondo metodo: lettura di un intero
	public int readInt ()
	{
		int input = Integer.parseInt (readLine());
		return input;
	}

	//terzo metodo: lettura di un double
	public double readDouble ()
	{
		double input = Double.parseDouble (readLine());
		return input;
	}

	//quarto metodo: lettura di un char
	public char readChar () throws IOException
	{
		String s = readLine();
		if (s.length() > 1)
			throw new IOException();
		else
		{
			char[] c = s.toCharArray();
			return c[0];
		}
	}
}