/* 
	Esame del 12/12/2002:
	Definire una classe Java TreeList per una lista linkata 
	semplice in modo che i singoli nodi possano contenere 
	radici di alberi binari.

	Scrivere un metodo Java per la classe TreeList che ordini 
	la lista conl'algoritmo dell'Insertion Sort in base alle 
	altezze degli alberi. 

	public ListSort()
*/


/*************************************************************************
***************************classe TreeList********************************
*************************************************************************/
final class TreeList extends Object implements Comparable
{
	private BST tree;

	//costruttore senza argomenti:
	public TreeList ()
	{
		tree = new BST(); //inizializza un BST vuoto
	}

	//Costruttore:
	public TreeList (BST t)
	{
		tree = t;
	}

	//metodi di accesso/modifica:
	public BST getTree ()
	{
		return tree;
	}

	public void setTree (BST t)
	{
		tree = t;
	}

	//metodo che restiuisce una stringa contenente le info dell'albero
	public String toString ()
	{
		return preorderString (tree.getRoot());
	}

	private String preorderString (BSTNode t)
	{
		String output = "";
		if (t != null)
		{
			output += t.getKey();
			output += preorderString (t.getLeft());
			output += preorderString (t.getRight());
		}
		return output;
	}

	//implementazione del metodo compareTo dell'interfaccia java.lang.Comparable
	public int compareTo (Object t)
	{
		return compareTo ((BST)t);
	}

	private int compareTo (TreeList t)
	{
		if (((Comparable)tree).equals (t))
			return 0;
		else if (tree.getHeight(tree.getRoot()) < (t.getTree()).getHeight(t.getTree().getRoot()))
			return -1;
		else return 1;
	}

	//metodo per l'ordinamento (algoritmo insertionSort)
	public static void listSort (ListPlus l)
	{
		SortList.insertionSort (l);
	}
}


/*************************************************************************
*************************classe Esame12_12_02*****************************
*************************************************************************/
public class Esame12_12_02 extends Object
{
	//main:
	public static void main (String[] args)
	{    
		System.exit(1);
	}
}

