//Classe che implementa due metodi per il calcolo della funzione esponenziale

public class Exponential
{
	public static double recursiveExp (double x, double y)
	{
		if (y < 0)
			throw new IllegalArgumentException();
		if (y == 0)
			return 1.0;
		return x * recursiveExp (x, y - 1);
	}

	public static double iterativeExp (double x, double y)
	{
		if (y < 0)
			throw new IllegalArgumentException();
		if (y == 0)
			return 1.0;
		else
		{
			double r = x;
			while (y > 1)
			{
				r *= x;
				y--;
			}
			return r;
		}
	}

	//main:
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader();
		System.out.print ("Inserisci il valore della base: ");
		double x = console.readDouble ();
		System.out.print ("Inserisci il valore dell'esponente: ");
		double y = console.readDouble ();
		try
		{
			System.out.println (x+"^"+y+" (ricorsivo) = "+recursiveExp(x,y));
			System.out.println (x+"^"+y+" (iterativo) = "+recursiveExp(x,y));
		}
		catch (IllegalArgumentException e)
		{
			System.out.println (e+": esponente negativo.");
		}
		System.exit(1);
	}
}