//Classe che implementa due metodi per il calcolo del fattoriale di un numero intero

public class Factorial
{
	//1 metodo: fattoriale ricorsivo
	public static int recursiveFactorial (int n)
	{
		if (n < 0)
			throw new IllegalArgumentException();

		if (n == 0) return 1;

		else return n * recursiveFactorial (n - 1);
	}

	//2 metodo: fattoriale iterativo
	public static int iterativeFactorial (int n)
	{
		if (n < 0)
			throw new IllegalArgumentException();

		if (n == 0) return 1;

		else
		{
			int p = 1;
			for (int i = 2; i <= n; i++)
				p *= i;
			return p;
		}
	}

	//main:
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader();
		System.out.print ("Inserisci un numero intero: ");
		int n = console.readInt ();
		try
		{
			System.out.println ("Fattoriale di "+n+" (ricorsivo) = "+recursiveFactorial(n));
			System.out.println ("Fattoriale di "+n+" (iterativo) = "+iterativeFactorial(n));
		}
		catch (IllegalArgumentException e)
		{
			System.out.println (e);
		}
		System.exit(1);
	}
}
