//Classe per il calcolo dell'n-esimo numero della serie di Fibonacci

public class Fibonacci
{
	public static int recursiveFib (int n)
	{
		if (n < 0)
			throw new IllegalArgumentException();
		if (n < 2)
			return 1;
		else return recursiveFib (n - 2) + recursiveFib (n - 1);
	}

	public static int iterativeFib (int n)
	{
		if (n < 0)
			throw new IllegalArgumentException ();
		if (n < 2)
			return n;
		else
		{
			int i = 2, tmp, current = 1, last = 0;
			for ( ; i <= n; i++)
			{
				tmp = current;
				current += last;
				last = tmp;
			}
			return current;
		}
	}

	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader ();
		System.out.print ("Inserisci un numero intero positivo: ");
		int n = console.readInt ();
		try
		{
			System.out.println (
			"L'"+n+"o numero della serie di Fibonacci (ricorsiva) e': "+recursiveFib(n));
		}
		catch (IllegalArgumentException e)
		{
			System.out.println (e+": il numero dato in input e' negativo!");
		}
		System.out.println (
			"L'"+n+"o numero della serie di Fibonacci (iterativa) e': "+iterativeFib(n));
		System.exit(1);
	}
}