//Programma che copia un file in un altro in ordine inverso

import java.io.*;

public class InvertiFile
{
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader ();
		RandomAccessFile fileInput = null;
		RandomAccessFile fileOutput = null;
		boolean controllo = false;
		
		//inserimento del nome del file di input
		do
		{
			controllo = false;
			System.out.print ("Inserisci il nome del file da copiare: ");
			String nomeInput = console.readLine();
			try
			{
				fileInput = new RandomAccessFile (nomeInput, "r");
			}
			catch (FileNotFoundException exc)
   		{
				System.out.println ("Il file non esiste.");
				controllo = true;
			}
		}
		while (controllo);
	
		//inserimento del nome del file di output
		System.out.print ("Inserisci il nome del file di destinazione: ");
		String nomeOutput = console.readLine();
		try
		{
			fileOutput = new RandomAccessFile (nomeOutput, "rw");
		}
		catch (IOException e)
		{
			System.out.println (e+": errore nell'apertura del file di output.");
			System.exit(1);
		}
		
		//fase di scrittura
		try
		{
			long pos;
			int n;
			for (pos = fileInput.length(); pos > 0; pos--)
			{
				fileInput.seek(pos-1);
				n = fileInput.read();
				fileOutput.writeByte((char)n);
			}
			fileInput.close();
			fileOutput.close();
		}
		catch(IOException e)
		{
			System.out.println (e);
			System.exit(1);
		}
	}
}
