//Metodi per l'inversione di una lista concatenata semplice:

public class InvertiLista
{
	public static void inversion (ListPlus a)
	{
		if (a.isEmpty())
			throw new EmptyListException();
		StackList supp = new StackList ();
		while (!a.isEmpty())
			supp.push (a.deleteHead());
		while (!supp.isEmpty())
			a.insertTail (supp.pop());
	}

	public static void recursiveInversion (IntListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException ();
		recursiveInversion (list, list.getHead(), list.getHead());
	}

	private static void recursiveInversion (IntListPlus list, IntNode supp, IntNode aux)
	{
		if (supp == aux)
		{
			list.insertHead(list.deleteTail());
			supp = list.getHead();
		}
		if (aux.getNext() != null)
		{
			IntNode tmp = new IntNode (list.deleteTail());
			supp.setNext (tmp);
			supp.getNext().setNext (aux);
			recursiveInversion (list, supp.getNext(), aux);
		}
	}

	//main:
	public static void main (String[] args)
	{
		IntListPlus lista = new IntListPlus();
		Lists.inizialize (lista);
		System.out.print ("Lista originale: ");
		Lists.printList (lista);
		recursiveInversion (lista);
		System.out.print ("Lista invertita: ");
		Lists.printList (lista);
		System.exit(1);
	}
}