/*
	Scrivere un metodo statico in Java che, date due Liste 
	concatenate semplici ordinate (e non), trovi tutte le occorrenze 
	dellintera seconda Lista allinterno della prima.
*/

public class OccorrenzeLista
{
	public static int ricercaOccorrenze (IntListPlus a, IntListPlus b)
   {
		if (a.isEmpty() || b.isEmpty())
			throw new EmptyListException ();
		a.rewind(); b.rewind();
		int m = a.getNextElem();
		int n = b.getNextElem();
		int occorrenze = 0;
		boolean controllo = false;

		while (!controllo)
		{
			try
			{
				while (m != n)
					m = a.getNextElem();
			}
			catch (OutOfListException e)
			{
				return occorrenze;
			}
			try
			{
				while (m == n)
				{
					n = b.getNextElem();
					m = a.getNextElem();
				}
			}
			catch (OutOfListException exc)
			{
				try
				{
					a.getNextElem();
				}
				catch (OutOfListException exception)
				{
					if (n == m)
						occorrenze++;
					return occorrenze;
				}
				occorrenze++;
			}
			b.rewind();
		}
		return occorrenze;
	}

	//lista ordinata
	public static int ricercaOccorrenzeOrd (IntListPlus a, IntListPlus b)
	{
		if (a.isEmpty() || b.isEmpty())
			throw new EmptyListException();
		a.rewind();
		b.rewind();
		int m = a.getNextElem ();
		int n = b.getNextElem ();
		boolean controllo = false;
		while (!controllo)
		{
			try
			{
				while (m != n)
				{
					m = a.getNextElem();
				}
			}
			catch (OutOfListException e) //lista a terminata
			{
				return 0; //nessuna occorrenza
			}
			try //sono stati trovati due elementi uguali
			{
				while (m == n)
				{
					n = b.getNextElem ();
					m = a.getNextElem ();
				}
			}
			catch (OutOfListException e) //una delle due liste  terminata
			{
				//controllo quel fra le due liste  terminata:
				try
				{
					a.getNextElem();
				}
				catch (OutOfListException exc) // terminata la lista a
				{
					if (m == n)
						return 1;
				}
				// terminata prima la lista b:
				controllo = true;
			}
		}
		return 1; 	 //non possono esservi ulteriori occorrenze
	}
	

	//main:
	public static void main (String[] args)
	{
		IntListPlus lista2 = new IntListPlus ();
		lista2.insertOrdered (3);
		lista2.insertOrdered (4);

		// 1 test:
		IntListPlus lista1 = new IntListPlus ();
		lista1.insertOrdered (1);
		lista1.insertOrdered (3);
		lista1.insertOrdered (4);
		lista1.insertOrdered (7);
		System.out.println ("Test n.1, occorrenze = "+ricercaOccorrenze(lista1, lista2));
		//occorrenze = 1

		// 2 test:
		lista1.insertTail (3);
		lista1.insertTail (4);
		lista1.insertTail (7);
		System.out.println ("Test n.2, occorrenze = "+ricercaOccorrenze(lista1, lista2));
		//occorrenze = 2

		// 3 test:
		lista1.clear();
		lista1.insertOrdered (2);
		lista1.insertOrdered (3);
		System.out.println ("Test n.3, occorrenze = "+ricercaOccorrenze(lista1, lista2));
		//occorrenze = 0

		// 4 test:
		lista1.insertTail (4);
		System.out.println ("Test n.4, occorrenze = "+ricercaOccorrenze(lista1, lista2));
		//occorrenze = 1

		System.exit(1);
	}
}
