//Classe Person da utilizzare per implementare la classe Lista generica

public class Person implements Comparable //per rendere due oggetti di tipo Person confrontabili
{
	protected String name;
	protected int age;

	//costruttore senza argomenti
	public Person ()
	{
		this ("", 0);
	}

	//Costruttore:
	public Person (String n, int a)
	{
		name = n;
		age = a;
	}

	//metodo toString() ridefinito per la visualizzazione delle info sulla persona
	public String toString()
	{
		return name + " "+ age;
	}

	//ridefinizione di equals() per verificare se due persone hanno gli stessi dati
	public boolean equals (Object p)
	{
		if (p == null)
		{
			throw new NullPointerException();
		}
		else return (name.equals(((Person)p).getName()) && age == ((Person)p).getAge());
	}

	public int compareTo (Object o) //ridefinizione di compareTo di java.lang.Comparable
	{
		if ((this.getName()).equals(((Person)o).getName()))
			return name.compareTo(((Person)o).getName());
		else return this.getAge() - ((Person)o).getAge();
	}

	//metodi di accesso:
	public int getAge()
	{
		return age; 
	}
	
	public String getName()
	{
		return name; 
	}

	//metodi di modifica:
	public void setAge (int a)
	{
		age = a;
	}

	public void setName (String n)
	{
		name = n;
	}
}
