/*
	Esame del 18/02/2003
	Scrivere un metodo statico Java 
	void InsList( Tree T, int n, int k, Object l)
	che, preso in input un albero binario T, rimpiazzi 
	l'etichetta del nodo n-esimo(contando da sinistra 
	verso destra) del livello K-esimo, qualora esista, 
	con l'etichetta l.
*/

/* Implementazione con BST d'interi */

public class RimpiazzaNodo
{
	public static void insList (IntBST t, int n, int k, int l)
	{
		if (t.isEmpty(t.getRoot()))
			throw new EmptyTreeException ();
		else insList (t.getRoot(), n, k, l);
	}

	private static void insList (IntBSTNode p, int n, int k, int l)
	{
		QueueList queue = new QueueList ();
		QueueList supp = new QueueList ();
		int i = 0;
		supp.enQueue (p);
		for (; i < k || !supp.isEmpty() ; i++)
		{
			p = (IntBSTNode) supp.deQueue();
			if (p.getLeft() != null)
				queue.enQueue (p.getLeft());
			if (p.getRight() != null)
				queue.enQueue (p.getRight());
			if (supp.isEmpty())
				while (!queue.isEmpty())
					supp.enQueue(queue.deQueue());
			else
				i--;
		}
		for (i = 0; i < n; i++)
			supp.deQueue();
		p = (IntBSTNode) supp.deQueue();
		p = new IntBSTNode (l, p.getLeft(), p.getRight());
	}

	//main:
	public static void main (String[] args)
	{
		IntBST tree = new IntBST ();
		BinaryTrees.inizialize (tree);
		printBSTPreorder(tree);
		System.out.println();
		ConsoleReader console = new ConsoleReader();
		System.out.print ("Inserisci un valore: ");
		int l = console.readInt();
		System.out.print ("Inserisci il livello: ");
		int k = console.readInt();
		System.out.print ("Inserisci il numero del nodo: ");
		int n = console.readInt();
		insList (tree, n, k, l);
		printBSTPreorder (tree);
		System.out.println ();
		System.exit(1);
	}

	//metodo di stampa per il BST (mediante attraversamento PREORDER)
	public static void printBSTPreorder (IntBST t)
	{
		printBSTPreorder (t.getRoot());
	}

	private static void printBSTPreorder (IntBSTNode p)
	{
		if (p != null)
		{
			System.out.print (p.getKey()+ " ");
			printBSTPreorder (p.getLeft());
			printBSTPreorder (p.getRight());
		}
	}
}
