//Classe SearchArray (metodi per la ricerca lineare, binaria, del max. e del min. negli array)

public class SearchArray extends Object
{
	//RICERCA LINEARE:
	public static int search (int[] data, int key)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			if (data[i] == key)
				return i;
		return -1;
	}

	public static int search (double[] data, double key)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			if (data[i] == key)
				return i;
		return -1;
	}

	public static int search (char[] data, char key)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			if (data[i] == key)
				return i;
		return -1;
	}

	public static int search (Object[] data, Object key)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			if (data[i].equals(key))
				return i;
		return -1;
	}

	//RICERCA BINARIA:
	public static int binarySearch (int[] data, int key)
	{
		int low = 0, mid, high = data.length - 1;
		while (low <= high)
		{
			mid = (low + high) / 2;
			if (key < data[mid])
				high = mid - 1;
			else if (data[mid] < key)
				low = mid + 1;
			else return mid;
		}
		return -1;
	}

	public static int binarySearch (double[] data, double key)
	{
		int low = 0, mid, high = data.length - 1;
		while (low <= high)
		{
			mid = (low + high) / 2;
			if (key < data[mid])
				high = mid - 1;
			else if (data[mid] < key)
				low = mid + 1;
			else return mid;
		}
		return -1;
	}

	public static int binarySearch (char[] data, char key)
	{
		int low = 0, mid, high = data.length - 1;
		while (low <= high)
		{
			mid = (low + high) / 2;
			if (key < data[mid])
				high = mid - 1;
			else if (data[mid] < key)
				low = mid + 1;
			else return mid;
		}
		return -1;
	}

	public static int binarySearch (Object[] data, Object key)
	{
		int low = 0, mid, high = data.length - 1;
		while (low <= high)
		{
			mid = (low + high) / 2;
			if (((Comparable)key).compareTo(data[mid]) < 0)
				high = mid - 1;
			else if (((Comparable)data[mid]).compareTo(key) < 0)
				low = mid + 1;
			else return mid;
		}
		return -1;
	}

	//RICERCA DEL MAX:
	public static int searchMax (int[] data)
	{
		int max = 0, i = 0;
		for ( ; i < data.length; i++)
			if (data[i] > data[max])
				max = i;
		return max;
	}

	public static int searchMax (double[] data)
	{
		int max = 0, i = 0;
		for ( ; i < data.length; i++)
			if (data[i] > data[max])
				max = i;
		return max;
	}

	public static int searchMax (char[] data)
	{
		int max = 0, i = 0;
		for ( ; i < data.length; i++)
			if (data[i] > data[max])
				max = i;
		return max;
	}

	public static int searchMax (Object[] data)
	{
		int max = 0, i = 0;
		for ( ; i < data.length; i++)
			if (((Comparable)data[i]).compareTo(data[max]) > 0)
				max = i;
		return max;
	}

	//RICERCA DEL MINIMO:
	public static int searchMin (int[] data)
	{
		int min = 0, i = 0;
		for ( ; i < data.length; i++)
			if (data[i] < data[min])
				min = i;
		return min;
	}

	public static int searchMin (double[] data)
	{
		int min = 0, i = 0;
		for ( ; i < data.length; i++)
			if (data[i] < data[min])
				min = i;
		return min;
	}

	public static int searchMin (char[] data)
	{
		int min = 0, i = 0;
		for ( ; i < data.length; i++)
			if (data[i] < data[min])
				min = i;
		return min;
	}

	public static int searchMin (Object[] data)
	{
		int min = 0, i = 0;
		for ( ; i < data.length; i++)
			if (((Comparable)data[i]).compareTo(data[min]) < 0)
				min = i;
		return min;
	}
}