//Classe Sort con implementazione dei principali metodi per l'ordinamento degli array

public class SortArray
{
	/*************************************************
	***********Ordinamento per INSERIMENTO************
	*************************************************/

	//Array di int:
	public static void insertionSort (int[] data)
	{
		int tmp; //appoggio
		int i, j; //contatori
		for (i = 1; i < data.length; i++)
		{
			tmp = data[i];
			for (j = i; j > 0 && tmp < data[j-1]; j--)
				data[j] = data[j-1];
			data[j] = tmp;
		}
	}

	//Array di char:
	public static void insertionSort (char[] data)
	{
		char tmp; //appoggio
		int i, j; //contatori
		for (i = 1; i < data.length; i++)
		{
			tmp = data[i];
			for (j = i; j > 0 && tmp < data[j-1]; j--)
				data[j] = data[j-1];
			data[j] = tmp;
		}
	}

	//Array di double:
	public static void insertionSort (double[] data)
	{
		double tmp; //appoggio
		int i, j; //contatori
		for (i = 1; i < data.length; i++)
		{
			tmp = data[i];
			for (j = i; j > 0 && tmp < data[j-1]; j--)
				data[j] = data[j-1];
			data[j] = tmp;
		}
	}

	//Array di Object:
	public static void insertionSort (Object[] data)
	{
		Object tmp;
		int i, j;
		for (i = 1; i < data.length; i++)
		{
			tmp = data[i];
			for (j = i; j > 0 && ((Comparable)tmp).compareTo(data[j-1]) < 0; j--)
				data[j] = data[j-1];
			data[j] = tmp;
		}
	}

	//**************Ordinamento indiretto******************

	//Array di int:
	public static void insertionSort (int[] data, int[] pos)
	{
		int tmp;
		int i, j;
		//sincronizzazione di pos:
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		//algoritmo insertion sort:
		for (i = 1; i < pos.length; i++)
		{
			tmp = pos[i];
			for (j = i; j > 0 && data[tmp] < data[pos[j-1]]; j--)
				pos[j] = pos[j-1];
			pos[j] = tmp;
		}
	}

	//Array di char:
	public static void insertionSort (char[] data, int[] pos)
	{
		int tmp;
		int i, j;
		//sincronizzazione di pos:
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		//algoritmo insertion sort:
		for (i = 1; i < pos.length; i++)
		{
			tmp = pos[i];
			for (j = i; j > 0 && data[tmp] < data[pos[j-1]]; j--)
				pos[j] = pos[j-1];
			pos[j] = tmp;
		}
	}

	//Array di double:
	public static void insertionSort (double[] data, int[] pos)
	{
		int tmp;
		int i, j;
		//sincronizzazione di pos:
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		//algoritmo insertion sort:
		for (i = 1; i < pos.length; i++)
		{
			tmp = pos[i];
			for (j = i; j > 0 && data[tmp] < data[pos[j-1]]; j--)
				pos[j] = pos[j-1];
			pos[j] = tmp;
		}
	}

	//Array di Object:
	public static void insertionSort (Object[] data, int[] pos)
	{
		int tmp;
		int i, j;
		//sincronizzazione di pos:
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		//algoritmo insertion sort:
		for (i = 1; i < pos.length; i++)
		{
			tmp = pos[i];
			for (j = i; j > 0 && ((Comparable)data[tmp]).compareTo(data[pos[j-1]]) < 0; j--)
				pos[j] = pos[j-1];
			pos[j] = tmp;
		}
	}

	/*************************************************
	************Ordinamento per SELEZIONE*************
	*************************************************/

	//Array di int:
	public static void selectionSort (int[] data)
	{
		int i = 0, j = i+1 , least = i;
		for ( ; i < data.length; i++)
		{
			for ( ; j < data.length; j++)
				if (data[j] < data[least])
					least = j;
			swap (data, least, i);
		}
	}
	
	//Array di char:
	public static void selectionSort (char[] data)
	{
		int i = 0, j = i+1 , least = i;
		for ( ; i < data.length; i++)
		{
			for ( ; j < data.length; j++)
				if (data[j] < data[least])
					least = j;
			swap (data, least, i);
		}
	}

	//Array di double:
	public static void selectionSort (double[] data)
	{
		int i = 0, j = i+1 , least = i;
		for ( ; i < data.length; i++)
		{
			for ( ; j < data.length; j++)
				if (data[j] < data[least])
					least = j;
			swap (data, least, i);
		}
	}
	
	//Array di Object:
	public static void selectionSort (Object[] data)
	{	
		int i = 0, j = i+1 , least = i;
		for ( ; i < data.length; i++)
		{
			for ( ; j < data.length; j++)
				if (((Comparable)data[j]).compareTo(data[least]) < 0)
					least = j;
			swap (data, least, i);
		}
	}

	//**************Ordinamento indiretto******************

	//Array di int:
	public static void selectionSort (int[] data, int[] pos)
	{
		int i, j, least;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
		{
			for (j = i+1, least = i; j < pos.length; j++)
				if (data[pos[j]] < data[pos[least]])
					least = j;
			if (least != i)
				swap (pos, least, i);
		}
	}
	
	//Array di char:
	public static void selectionSort (char[] data, int[] pos)
	{
		int i, j, least;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
		{
			for (j = i+1, least = i; j < pos.length; j++)
				if (data[pos[j]] < data[pos[least]])
					least = j;
			if (least != i)
				swap (pos, least, i);
		}
	}

	//Array di double:
	public static void selectionSort (double[] data, int[] pos)
	{
		int i, j, least;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
		{
			for (j = i+1, least = i; j < pos.length; j++)
				if (data[pos[j]] < data[pos[least]])
					least = j;
			if (least != i)
				swap (pos, least, i);
		}
	}

	//Array di Object:
	public static void selectionSort (Object[] data, int[] pos)
	{
		int i, j, least;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
		{
			for (j = i+1, least = i; j < pos.length; j++)
				if (((Comparable)data[pos[j]]).compareTo(data[pos[least]]) < 0)
					least = j;
			if (least != i)
				swap (pos, least, i);
		}
	}

	/*************************************************
	***************Ordinamento a BOLLE****************
	*************************************************/
	
	//Array di int:
	public static void bubbleSort (int[] data)
	{
		int i, j;
		for (i = 0; i < data.length - 1; i++)
			for (j = data.length - 1; j > 0; j--)
				if (data[j] < data[j-1])
					swap (data, j, j-1);
	}
	
	//Array di char:
	public static void bubbleSort (char[] data)
	{
		int i, j;
		for (i = 0; i < data.length - 1; i++)
			for (j = data.length - 1; j > 0; j--)
				if (data[j] < data[j-1])
					swap (data, j, j-1);
	}

	//Array di double:
	public static void bubbleSort (double[] data)
	{
		int i, j;
		for (i = 0; i < data.length - 1; i++)
			for (j = data.length - 1; j > 0; j--)
				if (data[j] < data[j-1])
					swap (data, j, j-1);
	}

	//Array di Object:
	public static void bubbleSort (Object[] data)
	{
		int i, j;
		for (i = 0; i < data.length - 1; i++)
			for (j = data.length - 1; j > 0; j--)
				if (((Comparable)data[j]).compareTo(data[j-1]) < 0)
					swap (data, j, j-1);
	}

	//**************Ordinamento indiretto******************
	
	//Array di int:
	public static void bubbleSort (int[] data, int[] pos)
	{
		int i, j;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
			for (j = pos.length - 1; j > i; j--)
				if (data[pos[j]] < data[pos[j-1]])
					swap (pos, j, j-1);
	}

	//Array di char:
	public static void bubbleSort (char[] data, int[] pos)
	{
		int i, j;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
			for (j = pos.length - 1; j > i; j--)
				if (data[pos[j]] < data[pos[j-1]])
					swap (pos, j, j-1);
	}

	//Array di double:
	public static void bubbleSort (double[] data, int[] pos)
	{
		int i, j;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
			for (j = pos.length - 1; j > i; j--)
				if (data[pos[j]] < data[pos[j-1]])
					swap (pos, j, j-1);
	}

	public static void bubbleSort (Object[] data, int[] pos)
	{
		int i, j;
		for (i = 0; i < pos.length; i++)
			pos[i] = i;
		for (i = 0; i < pos.length; i++)
			for (j = pos.length - 1; j > i; j--)
				if (((Comparable)data[pos[j]]).compareTo(data[pos[j-1]]) < 0)
					swap (pos, j, j-1);
	}

	/*************************************************
	***************Ordinamento VELOCE*****************
	*************************************************/
	
	//Array di int:
	private static void quickSort (int[] data, int first, int last)
	{
		int lower = first + 1, upper = last;
		int pivot = data[first]; //scelgo come pivot il primo elemento dell'array o del sottoarray
		while (lower <= upper)
		{
			while (data[lower] < pivot)
				lower++;
			while (pivot < data[upper])
				upper--;
			if (lower < upper)
				swap (data, lower++, upper--);
			else lower++;
		}
		swap (data, upper, first);
		if (first < upper - 1)
			quickSort (data, first, upper - 1); //per il sottoarray con el. minori del pivot attuale
		if (upper + 1 < last)
			quickSort (data, upper + 1, last); //per il sottoarray con el. maggiori del pivot attuale
	}
	
	public static void quickSort (int[] data)
	{
		if (data.length < 2)
			return;
		int max = 0;
		//trovo l'elemento max e lo posiziono nell'ultima posizione
		for (int i = 1; i < data.length; i++)
			if (data[max] < data[i])
				max = i;
		swap (data, data.length - 1, max);
		//ora l'elemento max e' nella posizione corretta (l'ultima)
		quickSort (data, 0, data.length - 2);
	}
	
	//Array di char:
	private static void quickSort (char[] data, int first, int last)
	{
		int lower = first + 1, upper = last;
		char pivot = data[first]; //scelgo come pivot il primo elemento dell'array o del sottoarray
		while (lower <= upper)
		{
			while (data[lower] < pivot)
				lower++;
			while (pivot < data[upper])
				upper--;
			if (lower < upper)
				swap (data, lower++, upper--);
			else lower++;
		}
		swap (data, upper, first);
		if (first < upper - 1)
			quickSort (data, first, upper - 1); //per il sottoarray con el. minori del pivot attuale
		if (upper + 1 < last)
			quickSort (data, upper + 1, last); //per il sottoarray con el. maggiori del pivot attuale
	}

	public static void quickSort (char[] data)
	{
		if (data.length < 2)
			return;
		int max = 0;
		//trovo l'elemento max e lo posiziono nell'ultima posizione
		for (int i = 1; i < data.length; i++)
			if (data[max] < data[i])
				max = i;
		swap (data, data.length - 1, max);
		//ora l'elemento max e' nella posizione corretta (l'ultima)
		quickSort (data, 0, data.length - 2);
	}

	//Array di double:
	private static void quickSort (double[] data, int first, int last)
	{
		int lower = first + 1, upper = last;
		double pivot = data[first]; //scelgo come pivot il primo elemento dell'array o del sottoarray
		while (lower <= upper)
		{
			while (data[lower] < pivot)
				lower++;
			while (pivot < data[upper])
				upper--;
			if (lower < upper)
				swap (data, lower++, upper--);
			else lower++;
		}
		swap (data, upper, first);
		if (first < upper - 1)
			quickSort (data, first, upper - 1); //per il sottoarray con el. minori del pivot attuale
		if (upper + 1 < last)
			quickSort (data, upper + 1, last); //per il sottoarray con el. maggiori del pivot attuale
	}

	public static void quickSort (double[] data)
	{
		if (data.length < 2)
			return;
		int max = 0;
		//trovo l'elemento max e lo posiziono nell'ultima posizione
		for (int i = 1; i < data.length; i++)
			if (data[max] < data[i])
				max = i;
		swap (data, data.length - 1, max);
		//ora l'elemento max e' nella posizione corretta (l'ultima)
		quickSort (data, 0, data.length - 2);
	}
	
	//Array di Object:
	private static void quickSort (Object[] data, int first, int last)
	{
		int lower = first + 1, upper = last;
		Object pivot = data[first]; //scelgo come pivot il primo elemento dell'array o del sottoarray
		while (lower <= upper)
		{
			while (((Comparable)data[lower]).compareTo(pivot) < 0)
				lower++;
			while (((Comparable)pivot).compareTo(data[upper]) < 0)
 				upper--;
			if (lower < upper)
				swap (data, lower++, upper--);
			else lower++; //???
		}
		swap (data, upper, first);
		if (first < upper - 1)
			quickSort (data, first, upper - 1); //per il sottoarray con el. minori del pivot attuale
		if (upper + 1 < last)
			quickSort (data, upper + 1, last); //per il sottoarray con el. maggiori del pivot attuale
	}

	public static void quickSort (Object[] data)
	{
		if (data.length < 2)
			return;
		int max = 0;
		//trovo l'elemento max e lo posiziono nell'ultima posizione
		for (int i = 1; i < data.length; i++)
			if (((Comparable)data[max]).compareTo(data[i]) < 0)
				max = i;
		swap (data, data.length - 1, max);
		//ora l'elemento max e' nella posizione corretta (l'ultima)
		quickSort (data, 0, data.length - 2);
	}

	/*************************************************
	*************Ordinamento per FUSIONE**************
	*************************************************/
	
	//Array di int:
	public static int[] temp1; //supporto

	public static void mergeSort (int[] data)
	{
		temp1 = new int [data.length];
		mergeSort (data, 0, data.length - 1);
	}

	private static void mergeSort (int[] data, int first, int last)
	{
		if (first < last)
		{
			int mid = (first + last) / 2;
			mergeSort (data, first, mid);
			mergeSort (data, mid + 1, last);
			merge (data, first, last);
		}
	}

	private static void merge (int[] data, int first, int last)
	{
		int mid = (first + last) / 2;
		int i1= 0, i2 = first, i3 = mid + 1;
		while (i2 <= mid && i3 <= last)
			if (data[i2] < data[i3])
				temp1[i1++] = data[i2++];
			else
				temp1[i1++] = data[i3++];
		while (i2 <= mid)
			temp1[i1++] = data[i2++];
		while (i3 <= last)
			temp1[i1++] = data[i3++];
		for (i1 = 0, i2 = first; i2 <= last; data[i2++] = temp1[i1++]) ;
	}

	//Array di char:
	public static char[] temp2; //supporto

	public static void mergeSort (char[] data)
	{
		temp2 = new char [data.length];
		mergeSort (data, 0, data.length - 1);
	}

	private static void mergeSort (char[] data, int first, int last)
	{
		if (first < last)
		{
			int mid = (first + last) / 2;
			mergeSort (data, first, mid);
			mergeSort (data, mid + 1, last);
			merge (data, first, last);
		}
	}

	private static void merge (char[] data, int first, int last)
	{
		int mid = (first + last) / 2;
		int i1= 0, i2 = first, i3 = mid + 1;
		while (i2 <= mid && i3 <= last)
			if (data[i2] < data[i3])
				temp2[i1++] = data[i2++];
			else
				temp2[i1++] = data[i3++];
		while (i2 <= mid)
			temp2[i1++] = data[i2++];
		while (i3 <= last)
			temp2[i1++] = data[i3++];
		for (i1 = 0, i2 = first; i2 <= last; data[i2++] = temp2[i1++]) ;
	}

	//Array di double:
	public static double[] temp3; //supporto

	public static void mergeSort (double[] data)
	{
		temp3 = new double [data.length];
		mergeSort (data, 0, data.length - 1);
	}

	private static void mergeSort (double[] data, int first, int last)
	{
		if (first < last)
		{
			int mid = (first + last) / 2;
			mergeSort (data, first, mid);
			mergeSort (data, mid + 1, last);
			merge (data, first, last);
		}
	}

	private static void merge (double[] data, int first, int last)
	{
		int mid = (first + last) / 2;
		int i1= 0, i2 = first, i3 = mid + 1;
		while (i2 <= mid && i3 <= last)
			if (data[i2] < data[i3])
				temp3[i1++] = data[i2++];
			else
				temp3[i1++] = data[i3++];
		while (i2 <= mid)
			temp3[i1++] = data[i2++];
		while (i3 <= last)
			temp3[i1++] = data[i3++];
		for (i1 = 0, i2 = first; i2 <= last; data[i2++] = temp3[i1++]) ;
	}

	//Array di Object:
	public static Object[] temp; //supporto

	public static void mergeSort (Object[] data)
	{
		temp = new Object [data.length];
		mergeSort (data, 0, data.length - 1);
	}

	private static void mergeSort (Object[] data, int first, int last)
	{
		if (first < last)
		{
			int mid = (first + last) / 2;
			mergeSort (data, first, mid);
			mergeSort (data, mid + 1, last);
			merge (data, first, last);
		}
	}

	private static void merge (Object[] data, int first, int last)
	{
		int mid = (first + last) / 2;
		int i1= 0, i2 = first, i3 = mid + 1;
		while (i2 <= mid && i3 <= last)
			if (((Comparable)data[i2]).compareTo(data[i3]) < 0)
				temp[i1++] = data[i2++];
			else
				temp[i1++] = data[i3++];
		while (i2 <= mid)
			temp[i1++] = data[i2++];
		while (i3 <= last)
			temp[i1++] = data[i3++];
		for (i1 = 0, i2 = first; i2 <= last; data[i2++] = temp[i1++]) ;
	}

	/*************************************************
	****************metodi per lo SWAP****************
	*************************************************/
	public static void swap (int[] a, int m, int n)
	{
		int tmp = a[m];
		a[m] = a[n];
		a[n] = tmp;
	}

	public static void swap (char[] a, int m, int n)
	{
		char tmp = a[m];
		a[m] = a[n];
		a[n] = tmp;
	}

	public static void swap (double[] a, int m, int n)
	{
		double tmp = a[m];
		a[m] = a[n];
		a[n] = tmp;
	}

	public static void swap (Object[] a, int m, int n)
	{
		Object tmp = a[m];
		a[m] = a[n];
		a[n] = tmp;
	}

	//metodi per ordinare arrays tramite array di indici:

	public static void sort (int[] data, int[] pos)
	{
		int tmp;
		int i, j, k;
		for (i = 0; i < pos.length; i++)
		{
			if (pos[i] != i)
			{
				tmp = data[i];	  //memorizza il primo record
				k = i;			  //k contiene la prima posizione
				do
				{
					j = k;								//segue la catena
					data[j] = data[pos[j]];
					k = pos[j];						   //prende la posizione successiva
					pos[j] = j;						   //l'elemento j-esimo  in pos. j
				}
				while (k != i); //finch non ritorna all'inizio
				data[j] = tmp;
			}
		}
	}

	public static void sort (char[] data, int[] pos)
	{
		char tmp;
		int i, j, k;
		for (i = 0; i < pos.length; i++)
		{
			if (pos[i] != i)
			{
				tmp = data[i];
				k = i;
				do
				{
					j = k;
					data[j] = data[pos[j]];
					k = pos[j];
					pos[j] = j;
				}
				while (k != i);
				data[j] = tmp;
			}
		}
	}

	public static void sort (double[] data, int[] pos)
	{
		double tmp;
		int i, j, k;
		for (i = 0; i < pos.length; i++)
		{
			if (pos[i] != i)
			{
				tmp = data[i];
				k = i;
				do
				{
					j = k;
					data[j] = data[pos[j]];
					k = pos[j];
					pos[j] = j;
				}
				while (k != i);
				data[j] = tmp;
			}
		}
	}

	public static void sort (Object[] data, int[] pos)
	{
		Object tmp;
		int i, j, k;
		for (i = 0; i < pos.length; i++)
		{
			if (pos[i] != i)
			{  
				tmp = data[i];
				k = i;
				do
				{
					j = k;
					data[j] = data[pos[j]];
					k = pos[j];
					pos[j] = j;
				}
				while (k != i);
				data[j] = tmp;
			}
		}
	}


	//main:
	public static void main (String[] args)
	{
		int[] a = {3, 2, 1, 4, 5};
		int[] p = new int [a.length];
		selectionSort (a, p);
		Vettori.visualizza (a);
		Vettori.visualizza (p);
		System.exit(1);
	}

	public static int scelta ()
	{
		ConsoleReader c = new ConsoleReader ();
		System.out.print ("Quanti elementi? ");
		return c.readInt();
	}
}
