//Classe con metodi per l'ordinamento di Liste concatenate

public class SortList
{
	/******************************************************
	**************Ordinamento per SELEZIONE****************
	******************************************************/
	
	//lista doppiamente concatenata di interi:
	public static void selectionSort (IntListDllPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		IntNodeDll i = list.getHead(), j, least;
		for ( ; i != list.getTail(); i = i.getNext())
		{
			for (j = i.getNext(), least = i ; j != null; j = j.getNext())
				if (j.getInfo() < least.getInfo())
					least = j;
			if (least != i)
				swap (least, i);
		}
	}

	//lista doppiamente concatenata di oggetti generici:
	public static void selectionSort (ListDllPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		NodeDll i = list.getHead(), j, least;
		for ( ; i != list.getTail(); i = i.getNext())
		{
			for (j = i.getNext(), least = i ; j != null; j = j.getNext())
				if (((Comparable)j.getInfo()).compareTo(least.getInfo()) < 0)
					least = j;
			if (least != i)
				swap (least, i);
		}
	}

	//lista semplicemente concatenata di interi:
	public static void selectionSort (IntListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		IntNode i, j , least;
		for (i = list.getHead(); i.getNext() != null; i = i.getNext())
		{
			for (j = i.getNext(), least = i; j != null; j = j.getNext())
				if (j.getInfo() < least.getInfo())
					least = j;
			if (least != i)
				swap (least, i);
		}
	}

	//lista semplicemente concatenata di oggetti generici:
	public static void selectionSort (ListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		Node i, j , least;
		for (i = list.getHead(); i.getNext() != null; i = i.getNext())
		{
			for (j = i.getNext(), least = i; j != null; j = j.getNext())
				if (((Comparable)j.getInfo()).compareTo(least.getInfo()) < 0)
					least = j;
			if (least != i)
				swap (least, i);
		}
	}

	/******************************************************
	*****************Ordinamento a BOLLE*******************
	******************************************************/

	//lista doppiamente concatenata di interi:
	public static void bubbleSort (IntListDllPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		IntNodeDll i, j;
		for (i = list.getHead(); i != list.getTail(); i = i.getNext())
			for (j = list.getTail(); j != list.getHead(); j = j.getPrev())
				if (j.getInfo() < j.getPrev().getInfo())
					swap (j, j.getPrev());
	}

	//lista doppiamente concatenata di oggetti generici:
	public static void bubbleSort (ListDllPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		NodeDll i, j;
		for (i = list.getHead(); i != list.getTail(); i = i.getNext())
			for (j = list.getTail(); j != list.getHead(); j = j.getPrev())
				if (((Comparable)j.getInfo()).compareTo (j.getPrev().getInfo()) < 0)
					swap (j, j.getPrev());
	}

	//lista semplicemente concatenata di interi:
	public static void bubbleSort (IntListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		IntNode i, j;
		//piccola variante: nei confronti vengono spostati gli elementi maggiori verso la fine
		for (i = list.getHead().getNext(); i != null; i = i.getNext())
			for (j = list.getHead(); j.getNext() != null; j = j.getNext())
				if (j.getInfo() > j.getNext().getInfo())
					swap (j, j.getNext());
	}

	//lista semplicemente concatenata di oggetti generici:
	public static void bubbleSort (ListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		Node i, j;
		//piccola variante: nei confronti vengono spostati gli elementi maggiori verso la fine
		for (i = list.getHead().getNext(); i != null; i = i.getNext())
			for (j = list.getHead(); j.getNext() != null; j = j.getNext())
				if (((Comparable)j.getInfo()).compareTo(j.getNext().getInfo()) > 0)
					swap (j, j.getNext());
	}

	/******************************************************
	*************Ordinamento per INSERIMENTO***************
	******************************************************/

	//lista doppiamente concatenata di interi:
	public static void insertionSort (IntListDllPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		int tmp; //campo info temporaneo
		IntNodeDll i, j;
		for (i = list.getHead().getNext(); i != null; i = i.getNext())
		{
			tmp = i.getInfo();
			for (j = i; j != list.getHead() && tmp < j.getPrev().getInfo(); j = j.getPrev())
				j.setInfo (j.getPrev().getInfo());
			j.setInfo (tmp);
		}
	}

	//lista doppiamente concatenata di oggetti generici:
	public static void insertionSort (ListDllPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		Object tmp; //campo info temporaneo
		NodeDll i, j;
		for (i = list.getHead().getNext(); i != null; i = i.getNext())
		{
			tmp = i.getInfo();
			for (	j = i; 
					j != list.getHead() && ((Comparable)tmp).compareTo(j.getPrev().getInfo()) < 0; 
					j = j.getPrev())
				j.setInfo (j.getPrev().getInfo());
			j.setInfo (tmp);
		}
	}

	//lista semplicemente concatenata di interi:
	public static void insertionSort (IntListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		IntNode i = list.getHead(), j , j_1;
		while (i.getNext() != null)
		{
			for (j = list.getHead(), j_1 = null;
				  j != i && j.getInfo() <= i.getNext().getInfo();
				  j_1 = j, j = j.getNext()) ;
			IntNode aux = i.getNext();
			i.setNext (aux.getNext());
			if (j == list.getHead())
			{
				aux.setNext (j);
				list.setHead (aux);
			}
			else
			{
				j_1.setNext (aux);
				aux.setNext (j);
			}
			if (i.getNext() == aux)
				i = i.getNext();
		}
	}

	//lista semplicemente concatenata di oggetti generici:
	public static void insertionSort (ListPlus list)
	{
		if (list.isEmpty())
			throw new EmptyListException();
		Node i = list.getHead(), j , j_1;
		while (i.getNext() != null)
		{
			for (j = list.getHead(), j_1 = null;
				  j != i && ((Comparable)j.getInfo()).compareTo(i.getNext().getInfo()) <= 0;
				  j_1 = j, j = j.getNext()) ;
			Node aux = i.getNext();
			i.setNext (aux.getNext());
			if (j == list.getHead())
			{
				aux.setNext (j);
				list.setHead (aux);
			}
			else
			{
				j_1.setNext (aux);
				aux.setNext (j);
			}
			if (i.getNext() == aux)
				i = i.getNext();
		}
	}

	/******************************************************
	*****************Ordinamento VELOCE********************
	******************************************************/

	//lista doppiamente concatenata di interi:
	public static IntListDllPlus quickSort (IntListDllPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		IntNodeDll pivot = list.getHead(), aux = list.getHead().getNext();
		IntListDllPlus smaller = new IntListDllPlus(), bigger = new IntListDllPlus();
		for ( ; aux != null; aux = aux.getNext())
			if (aux.getInfo() <= pivot.getInfo())
				smaller.insertHead (aux.getInfo());
			else
				bigger.insertHead (aux.getInfo());
		smaller = quickSort (smaller);
		bigger = quickSort (bigger);
		return concatena (smaller, pivot, bigger);
	}

	private static IntListDllPlus concatena (IntListDllPlus s, IntNodeDll p, IntListDllPlus b)
	{
		p.setNext (b.getHead());
		if (!s.isEmpty()) 
		{
			s.getTail().setNext (p);
			return s;
		}
		else
		{
			b.setHead (p);
			return b;
		}
	}

	//lista doppiamente concatenata di oggetti generici:
	public static ListDllPlus quickSort (ListDllPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		NodeDll pivot = list.getHead(), aux = list.getHead().getNext();
		ListDllPlus smaller = new ListDllPlus(), bigger = new ListDllPlus();
		for ( ; aux != null; aux = aux.getNext())
			if (((Comparable)aux.getInfo()).compareTo(pivot.getInfo()) <= 0)
				smaller.insertHead (aux.getInfo());
			else
				bigger.insertHead (aux.getInfo());
		smaller = quickSort (smaller);
		bigger = quickSort (bigger);
		return concatena (smaller, pivot, bigger);
	}

	private static ListDllPlus concatena (ListDllPlus s, NodeDll p, ListDllPlus b)
	{
		p.setNext (b.getHead());
		if (!s.isEmpty()) 
		{
			s.getTail().setNext (p);
			return s;
		}
		else
		{
			b.setHead (p);
			return b;
		}
	}
	
	//lista semplicemente concatenata di interi:
	public static IntListPlus quickSort (IntListPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		IntNode pivot = list.getHead(), aux = list.getHead().getNext();
		IntListPlus smaller = new IntListPlus(), bigger = new IntListPlus();
		for ( ; aux != null; aux = aux.getNext())
			if (aux.getInfo() <= pivot.getInfo())
				smaller.insertHead (aux.getInfo());
			else
				bigger.insertHead (aux.getInfo());
		smaller = quickSort (smaller);
		bigger = quickSort (bigger);
		return concatena (smaller, pivot, bigger);
	}

	private static IntListPlus concatena (IntListPlus s, IntNode p, IntListPlus b)
	{
		p.setNext (b.getHead());
		if (!s.isEmpty()) 
		{
			IntNode i = s.getHead();
			for ( ; i.getNext() != null; i = i.getNext()) ;
			i.setNext (p);
			return s;
		}
		else
		{
			b.setHead (p);
			return b;
		}
	}

	//lista semplicemente concatenata di oggetti generici:
	public static ListPlus quickSort (ListPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		Node pivot = list.getHead(), aux = list.getHead().getNext();
		ListPlus smaller = new ListPlus(), bigger = new ListPlus();
		for ( ; aux != null; aux = aux.getNext())
			if (((Comparable)aux.getInfo()).compareTo(pivot.getInfo()) <= 0)
				smaller.insertHead (aux.getInfo());
			else
				bigger.insertHead (aux.getInfo());
		smaller = quickSort (smaller);
		bigger = quickSort (bigger);
		return concatena (smaller, pivot, bigger);
	}

	private static ListPlus concatena (ListPlus s, Node p, ListPlus b)
	{
		p.setNext (b.getHead());
		if (!s.isEmpty()) 
		{
			Node i = s.getHead();
			for ( ; i.getNext() != null; i = i.getNext()) ;
			i.setNext (p);
			return s;
		}
		else
		{
			b.setHead (p);
			return b;
		}
	}


	/******************************************************
	***************Ordinamento per FUSIONE*****************
	******************************************************/

	//lista doppiamente concatenata di interi:
	public static IntListDllPlus mergeSort (IntListDllPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		IntListDllPlus list1 = new IntListDllPlus(), list2 = new IntListDllPlus();
		int size = list.getLength(), i = size;
		for ( ; i > size / 2; i--)
			list1.insertTail (list.deleteHead());
		while (!list.isEmpty())
			list2.insertTail (list.deleteHead());
		list1 = mergeSort (list1);
		list2 = mergeSort (list2);
		return merge (list1, list2);
	}

	private static IntListDllPlus merge (IntListDllPlus list1, IntListDllPlus list2)
	{
		IntListDllPlus list = new IntListDllPlus();
		while (!list1.isEmpty() && !list2.isEmpty())
			if (list1.getHead().getInfo() < list2.getHead().getInfo())
				list.insertTail (list1.deleteHead());
			else
				list.insertTail (list2.deleteHead());
		while (!list1.isEmpty())
			list.insertTail (list1.deleteHead());
		while (!list2.isEmpty())
			list.insertTail (list2.deleteHead());
		return list;
	}

	//lista doppiamente concatenata di oggetti generici:
	public static ListDllPlus mergeSort (ListDllPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		ListDllPlus list1 = new ListDllPlus(), list2 = new ListDllPlus();
		int size = list.getLength(), i = size;
		for ( ; i > size / 2; i--)
			list1.insertTail (list.deleteHead());
		while (!list.isEmpty())
			list2.insertTail (list.deleteHead());
		list1 = mergeSort (list1);
		list2 = mergeSort (list2);
		return merge (list1, list2);
	}

	private static ListDllPlus merge (ListDllPlus list1, ListDllPlus list2)
	{
		ListDllPlus list = new ListDllPlus();
		while (!list1.isEmpty() && !list2.isEmpty())
			if (((Comparable)list1.getHead().getInfo()).compareTo(list2.getHead().getInfo()) < 0)
				list.insertTail (list1.deleteHead());
			else
				list.insertTail (list2.deleteHead());
		while (!list1.isEmpty())
			list.insertTail (list1.deleteHead());
		while (!list2.isEmpty())
			list.insertTail (list2.deleteHead());
		return list;
	}

	//lista semplicemente concatenata di interi:
	public static IntListPlus mergeSort (IntListPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		IntListPlus list1 = new IntListPlus(), list2 = new IntListPlus();
		int size = list.getLength(), i = size;
		for ( ; i > size / 2; i--)
			list1.insertTail (list.deleteHead());
		while (!list.isEmpty())
			list2.insertTail (list.deleteHead());
		list1 = mergeSort (list1);
		list2 = mergeSort (list2);
		return merge (list1, list2);
	}

	private static IntListPlus merge (IntListPlus list1, IntListPlus list2)
	{
		IntListPlus list = new IntListPlus();
		while (!list1.isEmpty() && !list2.isEmpty())
			if (list1.getHead().getInfo() < list2.getHead().getInfo())
				list.insertTail (list1.deleteHead());
			else
				list.insertTail (list2.deleteHead());
		while (!list1.isEmpty())
			list.insertTail (list1.deleteHead());
		while (!list2.isEmpty())
			list.insertTail (list2.deleteHead());
		return list;
	}

	//lista semplicemente concatenata di oggetti generici:
	public static ListPlus mergeSort (ListPlus list)
	{
		if (list.isEmpty() || list.getHead().getNext() == null)
			return list;
		ListPlus list1 = new ListPlus(), list2 = new ListPlus();
		int size = list.getLength(), i = size;
		for ( ; i > size / 2; i--)
			list1.insertTail (list.deleteHead());
		while (!list.isEmpty())
			list2.insertTail (list.deleteHead());
		list1 = mergeSort (list1);
		list2 = mergeSort (list2);
		return merge (list1, list2);
	}

	private static ListPlus merge (ListPlus list1, ListPlus list2)
	{
		ListPlus list = new ListPlus();
		while (!list1.isEmpty() && !list2.isEmpty())
			if (((Comparable)list1.getHead().getInfo()).compareTo(list2.getHead().getInfo()) < 0)
				list.insertTail (list1.deleteHead());
			else
				list.insertTail (list2.deleteHead());
		while (!list1.isEmpty())
			list.insertTail (list1.deleteHead());
		while (!list2.isEmpty())
			list.insertTail (list2.deleteHead());
		return list;
	}

	/******************************************************
	********************SWAP dei nodi**********************
	******************************************************/
	public static void swap (IntNodeDll a, IntNodeDll b)
	{
		int tmp = a.getInfo();
		a.setInfo (b.getInfo());
		b.setInfo (tmp);
	}

	public static void swap (NodeDll a, NodeDll b)
	{
		Object tmp = a.getInfo();
		a.setInfo (b.getInfo());
		b.setInfo (tmp);
	}

	public static void swap (IntNode a, IntNode b)
	{
		int tmp = a.getInfo();
		a.setInfo (b.getInfo());
		b.setInfo (tmp);
	}

	public static void swap (Node a, Node b)
	{
		Object tmp = a.getInfo();
		a.setInfo (b.getInfo());
		b.setInfo (tmp);
	}

	//main:
	public static void main (String[] args)
	{
		System.exit(1);
	}
}
