/*************************************************************************
**************************classe Studente*********************************
*************************************************************************/
class Student extends Person implements Comparable
{
	protected int matricola;

	//metodi costruttori:
	public Student ()
	{
		super ();
		matricola = 0;
	}

	public Student (String n)
	{
		super (n, 0);
		matricola = 0;
	}

	public Student (String n, int a)
	{
		super (n, a);
		matricola = 0;
	}

	public Student (String n, int a, int m)
	{
		super (n, a);
		matricola = m;
	}

	public Student (int a)
	{
		super ("", a);
		matricola = 0;
	}

	public Student (int a, int m)
	{
		super ("", a);
		matricola = m;
	}

	//metodi di accesso/modifica:
	public int getMatricola ()
	{
		return matricola;
	}

	public void setMatricola (int m)
	{
		matricola = m;
	}

	public String toString()
	{
		return name+ " "+age+", matricola:"+matricola;
	}
	
	public int compareTo (Object o)
	{
		return compareTo ((Student)o);
	}

	private int compareTo (Student s)
	{
		if (!(this.getName()).equalsIgnoreCase(s.getName()))
			return ((this.getName()).compareTo(s.getName()));
		else
			return (this.getMatricola() - s.getMatricola());
	}

	public boolean equals (Object o)
	{
		return equals ((Student)o);
	}

	private boolean equals (Student o)
	{
		if (o == null)
			throw new NullPointerException();
		return (name.equals(o.getName()) && age == o.getAge() && matricola == o.getMatricola());
	}
}
