//Calcolo dell'unione di due insiemi numeri rappresentati mediante due BST:

public class UnioneBST
{
	public static IntBST getUnion (IntBST a, IntBST b)
	{
		if (a.isEmpty(a.getRoot()) && b.isEmpty(b.getRoot()))
			return new IntBST();
		else if (a.isEmpty(a.getRoot()))
			return b;
		else if (b.isEmpty(a.getRoot()))
			return a;
		else
		{
			QueueList supp = new QueueList(), queue = new QueueList();
			IntBST union = new IntBST();
			//inserisco gli elementi di a in supp provvisoriamente
			insertInQueue (a, supp);
			//copia di tutti gli elementi di a in union:
			IntBSTNode p = new IntBSTNode ();
			while (!supp.isEmpty())
			{
				p = (IntBSTNode) supp.deQueue();
				union.insert (p.getKey());
				//trasferisco gli elementi di a nella coda queue per riutilizzarli
				queue.enQueue(p);
			}
			//ricerco gli elementi di b diversi da quelli di a:
			int el1, el2;
			while (!queue.isEmpty())
			{
				el1 = ((IntBSTNode) queue.deQueue()).getKey();
				try
				{
					el2 = (b.search (p.getKey())).getKey();
					if (el1 != el2)
						union.insert (el1);
				}
				catch (NullPointerException e)
				{
				}
			}
			return union;
		}
	}

	private static void insertInQueue (IntBST tree, QueueList queue)
	{
		insertInQueue (tree.getRoot(), queue);
	}

	private static void insertInQueue (IntBSTNode node, QueueList queue)
	{
		if (node != null)
		{
			queue.enQueue (node);
			insertInQueue (node.getLeft(), queue);
			insertInQueue (node.getRight(), queue);
		}
	}

	//main:
	public static void main (String[] args)
	{
		IntBST a = new IntBST(), b = new IntBST();
		System.out.println ("BST 'a':");
		BinaryTrees.inizialize (a);
		System.out.println ("BST 'b':");
		BinaryTrees.inizialize (b);
		try
		{
			BinaryTrees.printPreorder (getUnion(a,b));
		}
		catch (EmptyTreeException e)
		{
			System.out.println ("Unione vuota");
		}
		System.exit(1);
	}
}