//Lista circolare semplicemente concatenata di INTERI

public class IntCircularList
{
	protected IntNode head;

	//Costruttore:
	public IntCircularList ()
	{
		head = null; 
	}

	//metodo che verifica se la lista  vuota
	public boolean isEmpty ()
	{
		return (head == null); 
	}

	public IntNode getHead ()
	{
		return head;
	}

	public void setHead (IntNode n)
	{
		head = n;
	}

	public int getLength ()
	{
		int cont = 1;
		IntNode aux = head;
		for ( ; aux.getNext() != head; cont++, aux = aux.getNext()) ;
		return cont;
	}

	//inserimento in testa
	public void insertHead (int val)
	{
   	if (isEmpty())
		{
			head = new IntNode (val);
			head.setNext(head);
		}
		else
		{
			//prima scorro la lista fino a raggiungere la coda
			IntNode aux = head;
			for ( ; aux.getNext() != head; aux = aux.getNext()) ;
			//aggancio l'elemento
			head = new IntNode (val, head);
			//cambio il riferimento alla coda
			aux.setNext (head);
		}
	}

	//inserimento in coda
	public void insertTail (int val)
	{
		if (isEmpty())
			insertHead (val);
		else
		{
		//scansione della lista fino alla coda
		IntNode aux = head;
		for ( ; aux.getNext() != head; aux = aux.getNext()) ;
		aux.setNext (new IntNode (val, head));
		}
	}
	
	//inserimento ordinato 
	public void insertOrdered (int val)
	{
		if (isEmpty() || val < head.getInfo())
			insertHead (val);
		else
		{
			//scansione della lista
			IntNode aux = head;
			for ( ; aux.getNext() != head && val > aux.getNext().getInfo(); aux = aux.getNext()) ;
			aux.setNext (new IntNode (val, aux.getNext()));
		}
	}

	//ricerca ordinata
	public IntNode searchOrd (int key)				 //key  la chiave di ricerca
	{
		if (key == head.getInfo())
			return head;
		else
		{
			IntNode aux = head.getNext();
			for (; aux != head && aux.getInfo() < key; aux = aux.getNext()) ;
			if (aux != null && aux.getInfo() == key)
				return aux;
			return null;	//nel caso in cui l'elemento da ricercare non fosse stato trovato
		}
	}

	//ricerca non ordinata
	public IntNode search (int key)
	{
		if (key == head.getInfo())
			return head;
		else
		{
			IntNode aux = head.getNext();
			for (; aux != head && aux.getInfo() != key; aux = aux.getNext()) ;
			return aux;
		}
	}
 
	//cancellazione della testa
	public int deleteHead ()
	{
		int r = 0;
		if (isEmpty())
			throw new EmptyListException();
		else if (head == head.getNext())
			head = null;
		else
		{
			//scansione della lista
			IntNode aux = head;
			for ( ; aux.getNext() != head; aux = aux.getNext()) ; //scansione
			r = head.getInfo();
			head = head.getNext(); //cancello il riferimento della testa
			aux.setNext(head); //modifico il riferimento della coda
		}
		return r;
	}

	//cancellazione della coda
	public int deleteTail ()
	{
		if (isEmpty())
			throw new EmptyListException();
		else
		{
			IntNode aux = head;
			IntNode prev = null; //precedente di aux
			//scansione della lista
			for ( ; aux.getNext() != head; prev = aux, aux = aux.getNext()) ;
			if (prev == head) //la lista ha un solo elemento
				head = null;
			else //la lista ha pi di un elemento
				prev.setNext(head);
			return aux.getInfo();
		}
	}

	//cancellazione di una chiave specifica della lista
	public IntNode deleteKey (int key)
	{
		IntNode aux = head.getNext();
		if (isEmpty())
			throw new EmptyListException();
		else if (key == head.getInfo()) //l'elemento da cancellare sar quello di testa
			deleteHead();
		else
		{
			IntNode prev = head;
			//scansione
			for ( ; aux != head && aux.getInfo() != key; prev = aux, aux = aux.getNext()) ;
			prev.setNext (aux.getNext());
		}
		return aux;
	}
}
