//Implementazione di una lista doppiamente linkata circolare di interi

public class IntCircularListDll
{
	protected IntNodeDll head, tail;

	//Costruttore:
	public IntCircularListDll ()
	{
		head = tail = null; 
	}

	//metodo che verifica se la lista  vuota
	public boolean isEmpty()
	{
		return (head == null); 
	}

	//metodo che restituisce il riferimento alla testa della lista
	public IntNodeDll getHead ()
	{
		return head; 
	}

	public void setHead (IntNodeDll n)
	{
		head = n;
	}

	//metodo che restituisce il riferimento alla coda della lista
	public IntNodeDll getTail ()
	{
		return tail; 
	}

	public void setTail (IntNodeDll n)
	{
		tail = n;
	}

	public int getLength ()
	{
		int cont = 1;
		IntNodeDll aux = head;
		for ( ; aux.getNext() != head; cont++, aux = aux.getNext()) ;
		return cont;
	}

	//metodo che cancella la lista
	public void clear ()
	{
		head = tail = null; 
	}

	/*		METODI PER L'INSERIMENTO	*/
	//inserimento in testa
	public void insertHead (int val)
	{
		if (isEmpty())
		{
			head = tail = new IntNodeDll (val);
			tail.setNext (head);
			head.setPrev (tail);
		}
		else
		{
			head = new IntNodeDll (val, tail, head);
			head.getNext().setPrev (head);
			tail.setNext (head);
		}
	}

	//inserimento in coda
	public void insertTail (int val)
	{
		if (isEmpty())
			insertHead(val);
		else
		{
			tail = new IntNodeDll (val, tail, head);
			tail.getPrev().setNext (tail);
			head.setPrev (tail);
		}
	}

	//inserimento ordinato
	public void insertOrdered (int val)
	{
		if (isEmpty() || val <= head.getInfo())
			insertHead (val);
		else
		{
			IntNodeDll aux = head;
			for( ; aux != tail && aux.getInfo() < val; aux = aux.getNext()) ;
			if (aux == tail)
				insertTail (val);
			else
			{
				aux.setPrev (new IntNodeDll (val, aux.getPrev(), aux));
				aux.getPrev().getPrev().setNext (aux.getPrev());
			}
		}
	}

	/*		METODI PER LA RICERCA	*/
	//ricerca su lista ordinata
	public IntNodeDll searchOrd (int key)
	{
		if (key == head.getInfo ())
			return head;
		else
		{
			IntNodeDll aux = head.getNext();
			for ( ; aux != head && aux.getInfo () < key; aux = aux.getNext()) ;
			if (aux != head && aux.getInfo () == key)
				return aux;
		}
		return null;
	}

	//ricerca su lista non ordinata
	public IntNodeDll search (int key)
	{
		if (key == head.getInfo ())
			return head;
		else
		{
			IntNodeDll aux = head.getNext();
			for ( ; aux != head && aux.getInfo () != key; aux = aux.getNext()) ;
			if (aux != head && aux.getInfo () == key)
				return aux;
		}
		return null;
	}

	/*		METODI PER LA CANCELLAZIONE	*/
	//cancellazione della testa
	public int deleteHead ()
	{
		if (isEmpty())
			throw new EmptyListException();
		int val = head.getInfo();
		if (head == head.getNext())
			head = tail = null;
		else
		{
			head = head.getNext();
			head.setPrev (tail);
			tail.setNext (head);
		}
		return val;
	}

	//cancellazione della coda
	public int deleteTail ()
	{
		if (isEmpty())
			throw new EmptyListException();
		int val = tail.getInfo();
		if (head == head.getNext())
			head = tail = null;
		else
		{
			tail = tail.getPrev();
			tail.setNext (head);
			head.setPrev (tail);
		}
		return val;
	}

	//cancellazione di un chiave specifica
	public IntNodeDll deleteKey (int key)
	{
		if (isEmpty())
			throw new EmptyListException();
		IntNodeDll aux = head;
		//l'elemento da cancellare  quello di testa
		if (head.getInfo() == key)
		{
			if (head.getNext() == head)
			{
				head = tail = null;
				return aux;
			}
			else
			{
				deleteHead();
				return aux;
			}
		}
		//l'elemento da cancellare non  di testa
		if (head == head.getNext())
			return null;
		aux = aux.getNext();
		for ( ; aux != head && aux.getInfo () != key; aux = aux.getNext()) ;
		if (aux != head) // stato trovato l'elemento ricarcato
		{
			if (aux == tail) // l'elemento di cada
			{
				deleteTail ();
				return aux;
			}
			else // un altro elemento
			{
				aux.getPrev().setNext (aux.getNext());
				aux.getNext().setPrev (aux.getPrev());
				return aux;
			}
		}
		return null;
	 }
}