// Implementazione mediante array di una semplice pila di numeri interi

import java.util.EmptyStackException;

public class IntStackArray
{
	private int top; //prima posizione libera in alto nella pila
	private final int MAX; //dimensione massima della pila (non modificabile)
	private int elem[]; //array atto a contenere la pila di interi
	private static final int MAX_DEFAULT = 10; //valore max di default (se non  fornito l'inizializzatore)

	//costruttore senza argomenti
	public IntStackArray ()
	{
		this (MAX_DEFAULT);
	}

	//Costruttore
	public IntStackArray (int max)
	{
		top = 0;
		MAX = max;
		elem = new int [MAX];
	}

	//metodo che restituisce il valore di MAX
	public int getDim ()
	{ return MAX; }

	//metodo che controlla se la pila  piena
	public boolean isFull ()
	{ return (top == MAX); }

	//metodo che controlla se la pila  vuota
	public boolean isEmpty ()
	{ return (top == 0); }

	//metodo che cancella l'intero contenuto della pila
	public void clear ()
	{ top = 0; }

	//metodo per l'inserimento di un elemento in cima alla pila
	public void push (int val)
	{
		if (isFull()) //se la pila  piena non pu essere inserito alcun elemento
			throw new FullStackException ();
		else
			elem[top++] = val; //prima incrementa top poi inserisce l'elemento
	}

	//metodo per l'estrazione dell'elemento in cima alla pila
	public int pop ()
	{
		if (isEmpty()) //se la pila  vuota non pu essere estratto alcun elemento
			throw new EmptyStackException ();
		else
			return elem [--top]; //prima decrementa top
	}

	//metodo che restituisce il primo elemento in cima alla pila senza estrarlo
	public int topElem ()
	{
		if (isEmpty())
			throw new EmptyStackException ();
		else 
			return elem [top - 1]; //non decrementa top!
	}
}