//Implementazione mediante array di una coda circolare di oggetti generici

public class QueueArray
{
	private int head, tail; //riferimenti alla testa ed alla coda
	private final int MAX;
	private Object [] elem; //spazio di memoria in cui allocare gli elementi
	private static final int MAX_DEFAULT = 10;

	//costruttore senza argomenti
	public QueueArray ()
	{ this (MAX_DEFAULT); }

	//Costruttore:
	public QueueArray (int max)
	{
		head = tail = 0;
		MAX = max;
		elem = new Object [MAX];
	}

	//metodo che verifica se la lista  piena
	public boolean isFull ()
	{ return (head == (tail + 1) % MAX); }

	//metodo che verifica se la lista  vuota
	public boolean isEmpty ()
	{ return (head == tail); }

	//metodo che cancella la struttura dati
	public void clear ()
	{ head = tail = 0; }

	//metodo che restituisce il primo elemento della coda
	public Object firstElem ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		return elem [head];
	}

	//metodo per l'inserimento di un elemento
	public void enQueue (Object obj)
	{
		if (isFull())
			throw new FullQueueException();
		elem [tail] = obj;
		tail = ++tail % MAX; //aggiornamento di tail
	}

	//metodo per l'estrazione di un elemento
	public Object deQueue ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		Object obj = elem[head];
		head = ++head % MAX; //aggiornamento di head
		return obj;
	}
}
