//Implementazione di una coda semplice generica mediante array

public class SimpleQueueArray
{
	private int head, tail;
	private final int MAX;
	private Object[] elem;
	private static final int MAX_DEFAULT = 10;

   //costruttore senza argomenti
	public SimpleQueueArray ()
	{
		this (MAX_DEFAULT);
	}

	//Costruttore:
	public SimpleQueueArray (int max)
	{
		head = tail = 0;
		MAX = max;
		elem = new Object[MAX];
	}

	//metodo che verifica se la coda  piena
	public boolean isFull()
	{	return (tail == elem.length - 1); }

	//metodo che verifica se la coda  vuota
	public boolean isEmpty()
	{	return (head == tail); }

	//metodo che cancella la coda
	public void clear ()
	{	head = tail = 0; }

	//metodo per l'inserimento
	public void enQueue (Object obj)
	{
		if (isFull())
			throw new EmptyQueueException();
		elem[++tail] = obj;
	}

	//metodo per l'etrazione
	public Object deQueue ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		Object obj = elem[head];
		for (int i = head; i <= tail; i++)
			elem[i] = elem [i+1];
		tail--;
		return obj;
	}

	//metodo che restituisce il primo elemento senza estrarlo
	public Object firstElem ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		return elem[head];
	}
}
