//Implementazione di una pila che si evolve verso il basso

import java.util.EmptyStackException;

public class StackDown
{
	private int top;
	private final int MAX;
	private Object [] elem;
	private static final int MAX_DEFAULT = 10;

	public StackDown ()
	{
		this (MAX_DEFAULT);
	}

	public StackDown (int max)
	{
		top = max - 1;
		MAX = max;
		elem = new Object [MAX];
	}

	public boolean isFull()
	{ return (top == 0); }

	public boolean isEmpty()
	{ return (top == MAX); }

	public void clear ()
	{ top = MAX - 1; }

	public void push (Object obj)
	{
		if (isFull())
			throw new FullStackException();
		else
			elem [top--] = obj;
	}

	public Object pop ()
	{
		if (isEmpty())
			throw new EmptyListException();
		else
			return elem [++top];
	}

	public Object topElem()
	{
		if (isEmpty())
			throw new EmptyListException();
		else
			return elem [top + 1];
	}
}