import java.io.*;

/*******************************************************
******************classe OrdinaLista********************
*******************************************************/
public class OrdinaLista
{
	public static void selectionSort (ListPlus l)
	{
		if (l.isEmpty())
			throw new EmptyListException();
		Node pi, pj, min;
		for (pi = l.getHead(); pi.getNext() != null; pi = pi.getNext())
		{
			for (pj = pi.getNext(), min = pi; pj != null; pj = pj.getNext())
			{
				if (((Comparable)pj.getInfo()).compareTo(min.getInfo()) < 0)
					min = pj;
				if (pi != min)
				{
					if (pi != l.getHead())
					{
						for (pj = l.getHead(); pj.getNext() != pi; pj = pj.getNext()) ;
						pj.setNext (min);
					}
					else
						l.setHead(min);
					Node tmp = min.getNext();
					for (pj = pi; pj.getNext() != min; pj = pj.getNext()) ;
					if (min != pi.getNext())
					{
						min.setNext(pi.getNext());
						pi.setNext(tmp);
						pj.setNext (pi);
					}
					else
					{
						min.setNext(pi);
						pj.setNext(tmp);
 					}
					pi = min;
				}
			}
		}
	}

	public static void printList (ListPlus l)
	{
		if (l.isEmpty())
			System.out.println ("Lista vuota.");
		Node aux = head;
		for ( ; aux.getNext() != null; aux = aux.getNext())
			System.out.println (aux.getInfo());
	}

	public static void inizialize (ListPlus l)
	{
		/*boolean flag = false;
		String scelta = "", tipo = "";
		while (!flag)
		{
			System.out.print ("Vuoi inserire un elemento? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				boolean check = false;
				while (!check)
				{
					System.out.print ("Che tipo d'inserimento: (TESTA, CODA, ORDINATO): ");
					tipo = console.readLine();
					if (tipo.equalsIgnoreCase("TESTA") || 
					tipo.equalsIgnoreCase("CODA") || tipo.equalsIgnoreCase("ORDINATO"))
						check = true;
				}
				System.out.print ("Digita il valore di KEY1: ");
				if (tipo.equalsIgnoreCase("TESTA"))
					l.insertHead (console.readInt());
				else if (tipo.equalsIgnoreCase("CODA"))
					l.insertTail (console.readInt());
				else if (tipo.equalsIgnoreCase("ORDINATO"))
					l.insertTail (console.readInt());
				else continue;
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}*/
	}

	//main:
	public static void main (String[] args)
	{
		System.exit(0);
	}
}

/*******************************************************
********************classe Student**********************
*******************************************************/
class Student implements Comparable
{
	private String name;
	private int key1, key2;

	public Student (int a, int b)
	{
		this ("", a, b);
	}

	public Student (String n, int a, int b)
	{
		name = n;
		key1 = a;
		key2 = b;
	}

	public int getKey1 ()
	{
		return key1;
	}

	public int getKey2 ()
	{
		return key2;
	}

	public int compareTo (Object o)
	{
		return this.compareTo ((Student)o);
	}

	private int compareTo (Student s)
	{
		if (key1 == s.getKey1())
			return key2 - s.getKey2();
		else
			return key1 - s.getKey1();
	}

	public String toString ()
	{
		return "key1: "+key1+", key2: "+key2;
	}
}

/*******************************************************
*****************classe ConsoleReader*******************
*******************************************************/
class ConsoleReader
{
	private BufferedReader reader;

	//Costruttore
	public ConsoleReader ()
	{
		reader = new BufferedReader (new InputStreamReader (System.in));
	}

	public String readLine ()
	{
		String inputLine = "";
		try {
			inputLine = reader.readLine();
		}
		catch (IOException e) {
			System.out.println (e);
			System.exit(1);
		}
		return inputLine;
	}

	public int readInt ()
	{
		int input = Integer.parseInt (readLine());
		return input;
	}
}

/*******************************************************
*********************classe List************************
*******************************************************/
class List
{
	protected Node head;
	
	//Costruttore:
	public List ()
	{
		head = null;	//inizializzo una List generica vuota
	}

	//metodo che restituisce il riferimento alla testa della lista
	public Node getHead()
	{
		return head;
	}

	//metodo che modifica il riferimento alla testa
	public void setHead (Node node)
	{
		head = node;
	}
	
	//metodo che controlla se la List  vuota
	public boolean isEmpty ()
	{
		return (head == null);
	}
	
	//INSERIMENTO:
	//inserimento in testa
	public void insertHead (Object o)
	{
		head = new Node (o, head);
	}

	//inserimento in coda
	public void insertTail (Object o)
	{
		//controllo se la List  vuota
		if (isEmpty())
		{
			//creo una nuova List
			head = new Node (o);
		}
		else
		{
			Node aux = head;
			for (; aux.getNext() != null; aux = aux.getNext());
			aux.setNext (new Node (o));
		}
	}

	//inserimento ordinato
	public void insertOrdered (Object o)
	{
		//controllo se la List  vuota
		if (isEmpty())
		{
			head = new Node (o, head);
		}
		//altrimenti controllo se l'elemento da inserire  minore dell'elemento di testa
		else if (((Comparable)head.getInfo()).compareTo(o) > 0)
		{
			//inserimento in testa
			insertHead (o);
		}
		//come ultima alternativa devo scorrere la List fino alla posizione corretta
		else
		{
			//scansione:
			Node aux = head;
			for (; aux.getNext() != null && ((Comparable)aux.getInfo()).compareTo(o) < 0; 
					 aux = aux.getNext());
			//posso "agganciare" l'elemento
			aux.setNext(new Node(o, aux.getNext()));
		}
	}

	//RICERCA:
	//ricerca ordinata
	public Node searchOrd (Object key)
	{
		//scansione della List:
		Node aux = head;
		for ( ; aux.getNext() != null && ((Comparable)aux.getInfo()).compareTo(key) < 0;
				  aux = aux.getNext()) ;
		if (aux != null && (aux.getInfo().equals(key)))
			return aux;
		return null;
	}

	//ricerca non ordinata
	public Node search (Object key)
	{
		Node aux = head;
		for ( ; aux != null && !(aux.getInfo()).equals(key); aux = aux.getNext()) ;
		return aux;
	}

	//CANCELLAMENTO:
	//cancellamento della testa
	public Object deleteHead ()
	{
		//se la List  vuota genero un'eccezione di tipo EmptyListException
		if (isEmpty())
		{
			throw new EmptyListException();
		}
		else
		{
			Node aux = head;
			head = head.getNext();
			return aux.getInfo();
		}
	}

	//cancellamento della coda
	public Object deleteTail ()
	{
		if (isEmpty())
		{
			throw new EmptyListException();
		}
		else
		{
			Node aux = head;
			Node prev = null;
			for ( ; aux.getNext() != null; prev = aux, aux = aux.getNext()) ;
			if (prev == null) //allora la List  costituita da un solo elemento
			{
				prev = null;
			}
			else
			{
				prev.setNext(null);
			}
			return aux.getInfo();
		}
	}

	//cancellamento di un ben preciso elemento della List
	public Node deleteKey (Object key)
	{
		if (isEmpty())
		{
			throw new EmptyListException();
		}
		else
		{
			Node aux = head;
			Node prev = null;
			for ( ; aux != null && !(aux.getInfo().equals(key)); prev = aux, aux = aux.getNext()) ;
			if (aux != null)
			{
				if (prev == null)
				{
					head = head.getNext();
				}
				else
				{
					prev.setNext(aux.getNext());
				}
			}
			return aux;
		}
	}
}

/*******************************************************
**********************classe Node***********************
*******************************************************/
class Node
{
	protected Object obj;
	private Node next;

	public Node (Object o)
	{
		this (o, null);
	}

	public Node (Object o, Node n)
	{
		obj = o;
		next = n;
	}

	public Object getInfo ()
	{
		return obj;
	}

	public void setInfo (Object o)
	{
		obj = o;
	}

	public Node getNext ()
	{
		return next;
	}

	public void setNext (Node n)
	{
		next = n;
	}
}

/*******************************************************
****************classe EmptyListException***************
*******************************************************/
class EmptyListException extends RuntimeException
{
	public EmptyListException ()
	{
		super ("Attenzione la lista e' vuota!");
	}

	public EmptyListException (String msg)
	{
		super (msg);
	}
}
